## SyrusJS

### v1.26.0

-- Usage of new queue algorithm that reduce memory footprint and increase maximum stack of events to almost the whole available memory
-- fixed value of internal signal $timestamp
-- added new signal equivalent to $timestamp for spanish language \$tiempo
example

```
get value $tiempo # it returns 'Viernes, Diciembre 4, 2020 8:17 PM'
```

### v1.25.0

-- added json in ecu for multiple key values for fieldset=$ecu:$ecu, o fieldset=$ecu,
-- added new dev commands for get signals, get variables, get actions, get events, get fieldsets, get tracking_resolutions, get variables
get the raw definition as syruslang from configuration separated by `;`
example:
get signals # returns 'define signal out2on $io.out2;define signal out1on $io.out1'
-- fixed issue that without  a tracking_resolution syrusjs is not updating internal $gnss references, now data is available every second

### v1.24.0

#### Changelog:

-- added mqtt support for syruslang command in subscribe using new param commands_sub
-- added mqtt support for syruslang command in publish using new param commands_pub
-- fixed json type of key are being always string under certain conditions

## SyrusJS

### v1.23.0

#### Changelog:

-- added inputs 3,4,5,6 and 7 and ouputs 3 and 4 support for TAIP
-- added short circuit detection to outputs support for TAIP
-- added support for changing output 3 and output 4 using TAIP serial expander commands

### v1.22.1

#### Changelog:

-- added 2 new internal signal @geofence.enter and @geofence.exit fired in every geofence entered or exited

```
# geofence.entes and @geofence.exit are internal signal so no need to define a new signal
define event geoIn code=34 label=geoin fieldset=default trigger=@geofence.enter
define event geoOut code=35 label=geoout fieldset=default trigger=@geofence.exit
```

example:
-- added 2 new internal signal @geofence.group.enter and @geofence.group.exit fired in every geofence's group entered or exited
-- DEV: added new command fire signal to manually trigger signals.
Example:

```
fire signal IN1ON #(only available from remote console).
```

-- DEV: added new command set value to manually setting non internal values.
Example

```
set $geofences.test.inside true  #(only available from remote console).
```

### v1.22.0

#### Changelog:

-- added compatibility with apex-20.46.2 and new redis instance
-- added new flat retain in event for mqtt retain feature
example:
define event trackpoint retain=true code=1 label=trckpnt fieldset=default trigger=@tracking_resolution.mqtt.signal # this event will be retain by the mqtt broker as the last update available

### v1.21.0-beta

#### Changelog:

- fix inputs/outputs are on true after reset
- added support for configuration.json using json schema
- now it's possible change the configuration file using the json schema included on the app.
- now it's possible change the destinations file using the json schema included on the app.

### v1.20.0-beta

#### Changelog:

- fix issue double space on destinations
- upgrade syrus4-nodejs to support future versions of ApexOS (>20.44)
- speak alias now support multiple languages speak lang=es,speak lang=en, speak lang=fr, speak without arguments is passed as lang=en
- fixed ecu for TAIP commands
- since apex-20.44.00 syrusjs will stop processing geofences within geofences.syrus.conf file, you should consider import an export geofences from UI and apx-geofences-manager integrated tool, since is not blocking for the app and has much more options.
- added new command get detination_state that returns enable/disable for the connection:
  example

```
get destination_state peg
# must return `enable`
```

- improve support for HTTP/HTTPS destinations now support authentication, headers, params, method (by default POST), an better error logs.
- added simple schema definition for json schema support

### v1.19.1-beta

#### Changelog:

- fix issue that broken syrusjs when command depending of units are proccesed

### v1.19.0-beta

#### Changelog:

Starting with this version units are more explicit for arguments. follow specifications for syruslang new valid units are

1. speed=kph,mph,m/s
2. heading=deg,rad
3. dist=km,mts,mile,ft
4. time=hr,min,sec
5. cycle=rpm,hz
   old units schema will be supported but will emit a warning

- added new argument for actions and event called rate. Avoid fires event/action multiple times in x time defined.
  example:

```
define tracking_resolution 5sec
# avoids this event fires more than 5 times in 1min, units could be sec,min,hr
define event trckpnt code=1 label=trckpnt rate=5/1min trigger=@tracking_resolution.track.signal
```

- added new command 'send event EVENT_NAME' for forcely fire events within the destinations points
- added new command 'trigger action ACTION_NAME' for forcely trigger an event
- added new commands 'enable destination NAME' and 'disable destination NAME'. using this commands destination will be disconnected and stop sending events and receiving commands, but event will queued for connection will be available again.

- support for arguments subscribe and publish in mqtt destination

```
# DEPECRATION WARNING
# define destination mqtt_broker json mqtt://test.mosquitto.org:1883 protocol="mqtt" channelRx="dev/{{$modem.imei}}/messagestx" channelTx="dev/{{$modem.imei}}/messagestx"
# REPLACE FOR
define destination mqtt_broker json mqtt://test.mosquitto.org:1883 protocol="mqtt" subscribe="dev/{{$modem.imei}}/messagestx" publish="dev/{{$modem.imei}}/messagestx"
```

### v1.18.0-beta

#### Changelog:

- support SXAVO command in TAIP
- implement allowed_interface, allowed_ip and allowed_ssid (, for wifi only) to destinations, so destinations can be set to only works in specific enviroments (interface,ip,ssid)
  example:

```
# this connection will automatic disable outside wifi network and buffer the commands, when wifi is connected again all the messages on the buffer will be sent
define destination mqtt_broker json mqtt://test.mosquitto.org:1883 protocol="mqtt" subscribe="dev/messagestx" publish="dev/messagestx" allowed_interface=wifi
```

- allow use curly brackets to destination config and other commands
  example:

```
# define destination mqtt_broker json mqtt://test.mosquitto.org:1883 protocol="mqtt" subscribe="dev/{{$modem.imei}}/messagestx" publish="dev/{{$modem.imei}}/messagestx"

```

- Implement variables
  example:

```
define variable my_var "hello"
# you can define actions for change variables or just use as constants
set variable my_var "good bye"
define action aloha trigger=ignSwitch speak '{{$variables.my_var}}, driver'
```

- added new syruslang signal variable $mph, $kph, $speed, $timestamp, those are version more humanized of the $gnss.mph, $gnss.kph, $gnss.speed and $gnss.timestamp
  example:

```
speak 'today is {{$timestamp}}. The current speed is {{$kph}} kilometers per hour'
```

- supervise configuration.syruslang for changes and restart automatically the app

### v1.17.4-beta

#### Changelog:

- GPS data update every second, improve signal change detecttion
- added new alias bluetooth for apx-bt commands

### v1.17.3-beta

#### Changelog:

- Replace underscore (\_) for blank spaces in speak command

### v1.17.2-beta

#### Changelog:

- fix is inside notification on geofences and groups

### v1.17.1-beta

#### Changelog:

- added new configuration file geofences.syrus.conf. geofences.syrus.conf is only evaluated when changes are detected; Avoid to add commands different than signals on this file. (recommended move all geofences previously on configuration.syrus.conf to this file.)
- added new command speak alias for 'apx-mdm tts'. Usage: speak 'text to speech test'. only support english, the text must be encapsulated over single quoutes `'`
- added new values @last_geofence.name,@last_geofence.state and @last_geofence.time contains information about last geofence reported for apx-geofences core tool
- added ability to concatenate syrusjs signal variable on some exec commands.
  example:

```
STXspeak 'current location.  Latitude: {{$gnss.latitude}}.  Longitude:{{$gnss.longitude}}. Last Geofence reported: {{@last_geofence.name}} {{@last_geofence.state}}'
```

Variable must be inside notation {{ }}, variable is replaced in real time with current value of the syrusLang signal

### v1.16.1-beta

#### Changelog:

- fix ecu odometer parameter for TAIP
- fix ecu battery parameter for TAIP

### v1.16.0-beta

#### Changelog:

- geofences are now evaluated using apx-geofences utils from apexOS core
- added support for detecting process exit and clean disconnection from all the destinations point
- added new 38 parameters from ecu
- added new command set @ecu_params_response
- ecu signals and values now are accesible using id instead of aliases name
  example:

```
# ENGINE TOTAL FUEL USED
# previously $ecu.eng_tot_fuel now is
$ecu.fee9_5-8
```

### v1.15.2-beta

#### Changelog:

- added counters
- added new command define counters

```
# only name is mandatory
define counters name speed_threshold=50kph rpm_threshold=3000rpm begin_idle_time=300s odometer=0mts ignition_time=0s idle_time=0s over_speed=0s over_rpm=0 hard_brakes=0 harsh_fwd_acceleration=0
```

- added new command

```
# only name is mandatory
# require at least one new value to set
set counters name speed_threshold=50kph rpm_threshold=3000rpm begin_idle_time=300s odometer=0mts ignition_time=0s idle_time=0s over_speed=0s over_rpm=0 hard_brakes=0 harsh_fwd_acceleration=0
```

- added new command

```
stop counters name
```

- added new command

```
start counters name
```

- added new command

```
delete counters name
```

- added new values to syruslang signals

```
$counters.namespace.odometer
$counters.namespace.ignition_time
$counters.namespace.idle_time
$counters.namespace.over_speed
$counters.namespace.over_rpm

# example signal
define signal oil_change_required $counters.tecno.odometer > 20000
```

- added support to syruslang fieldset to use counters

```
# Example

define counters globals speed_threshold=50kph rpm_threshold=3000rpm begin_idle_time=300s odometer=0mts ignition_time=0s idle_time=0s over_speed=0s over_rpm=0 hard_brakes=0 harsh_fwd_acceleration=0

define counters driver speed_threshold=50kph rpm_threshold=3000rpm begin_idle_time=300s odometer=0mts ignition_time=0s idle_time=0s over_speed=0s over_rpm=0 hard_brakes=0 harsh_fwd_acceleration=0

define fieldset default fields=$io,$ecu,VO:$counters.globals.odometer,CE:$counters.globals.ignition_time,CL:$counters.globals.idle_time,CS:$counters.globals.over_speed,CR:$counters.globals.over_rpm,CV00:$counters.driver.odometer,CV01:$counters.driver.ignition_time


define signal driver_connected $net_wifi.ssid == "MOBILE HOTSPOT"
define action trigger=driver_connected start counters driver
define action trigger=driver_connected,not stop counters driver
```

- changed voltage thresholds and 100% to 4000 mV

### v1.14.4-beta

#### Changelog:

- improve tracking resolution detection arguments
- fix case when only tracking resolution had time with `m`
- added syruslang syruslang conversion for radianes

### v1.14.3-beta

#### Changelog:

- fixed empty arguments for tracking resolutions

### v1.14.2-beta

#### Changelog:

- fixed heading on taip events
- group warning when no group detected

### v1.14.0-beta

#### Changelog:

- changed signals from @tracking_resolution.signal to @tracking_resolution.{namespace}.signal where namespace is the name of the tracking resolution on define tracking_resolution command
- set tracking_resolution command changed to support new configuration of the tracking resolution, ej:

```
  define signal ignOnSignal $io.ign == true
  define tracking_resolution pegasus 10m
  define action ignOn trigger=ignOnSignal set @tracking_resolution pegasus 120s 25deg 100mts
```

- removed usage of set @tracking_resolution {name} as usage for change active tracking resolution in favor to have multiple tracking resolutions at the same time
